Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Windows.Forms
Namespace Client

	Public Class ClientClass
		Private SocketClient As Socket
		Private LocalsocketClientIsShutingDown As Boolean
		Private readbuf As Byte()
		Private sendbuf As Byte()
		Private listBox As ListBox

		private Delegate Sub DelegateDisplay(ByVal message As String)	
		private dlgDisplay as DelegateDisplay = new DelegateDisplay(addressof DisplayMessage)

		Public Sub New(ByVal list As System.Windows.Forms.ListBox)
			Me.listBox = list
			readbuf = New Byte(100) {}
		End Sub

		Public Sub ConnectToServer(ByVal ServerName As String)
			If Me.SocketClient Is Nothing OrElse Not Me.SocketClient.Connected Then
				Me.SocketClient = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
				Dim ipadress As IPAddress()
				Dim he As IPHostEntry = Dns.GetHostByName(ServerName)
				ipadress = he.AddressList
				Me.SocketClient.BeginConnect(New IPEndPoint(ipadress(0), 15), AddressOf ConnectCallback, Me.SocketClient)
			Else
				Dim obj As String() = New String() {"Dj connect un serveur"}
				Me.listBox.Invoke(dlgDisplay, obj)
			End If
		End Sub

		Private Sub ConnectCallback(ByVal asyncResult As IAsyncResult)
			Dim obj As String()
			Try
				Dim socket As Socket = CType(asyncResult.AsyncState, Socket)
				Me.SocketClient = socket
				socket.EndConnect(asyncResult)
				obj = New String() {"Connect  un serveur"}
				Me.listBox.Invoke(dlgDisplay, obj)
				Me.LocalsocketClientIsShutingDown = False
				Me.SocketClient.BeginReceive(Me.readbuf, 0, Me.readbuf.Length, SocketFlags.None, AddressOf ReceiveCallback, Me.SocketClient)
			Catch ex As SocketException
				obj = New String() {ex.Message}
				Me.listBox.Invoke(dlgDisplay, obj)
			End Try
		End Sub

		Public Sub SendMessage(ByVal message As String)
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				Me.sendbuf = Encoding.ASCII.GetBytes(message)
				Me.SocketClient.BeginSend(Me.sendbuf, 0, Me.sendbuf.Length, SocketFlags.None, AddressOf SendCallback, Me.SocketClient)
			Else
				DisplayMessage("Non connect au serveur.")
			End If
		End Sub

		Private Sub SendCallback(ByVal asyncResult As IAsyncResult)
			Dim obj As String()
			Try
				Dim socket As Socket = CType(asyncResult.AsyncState, Socket)
				Dim send As Integer = socket.EndSend(asyncResult)
				obj = New String() {"Message envoy (" + send.ToString() + " bytes envoys )"}
				Me.listBox.Invoke(dlgDisplay, obj)
			Catch ex As SocketException
				obj = New String() {ex.Message}
				Me.listBox.Invoke(dlgDisplay, obj)
			End Try
		End Sub

		Public Sub ReceiveMessage()
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				Me.SocketClient.BeginReceive(Me.readbuf, 0, Me.readbuf.Length, SocketFlags.None, AddressOf ReceiveCallback, Me.SocketClient)
			Else
				DisplayMessage("Non connect au serveur.")
			End If
		End Sub

		Private Sub ReceiveCallback(ByVal asyncResult As IAsyncResult)
			Dim obj As String()
			Try
				Dim socket As Socket = CType(asyncResult.AsyncState, Socket)
				Dim read As Integer = socket.EndReceive(asyncResult)
				If read > 0 Then
					obj = New String() {"Serveur dit :" + Encoding.ASCII.GetString(Me.readbuf)}
					Me.listBox.Invoke(dlgDisplay, obj)
					Me.SocketClient.BeginReceive(Me.readbuf, 0, Me.readbuf.Length, SocketFlags.None, AddressOf ReceiveCallback, Me.SocketClient)
				End If
				If read = 0 AndAlso Not Me.LocalsocketClientIsShutingDown Then
					Me.SocketClient.Close
					obj = New String() {"Fermeture socket distante"}
					Me.listBox.Invoke(dlgDisplay, obj)
				End If
				Buffer.SetByte(Me.readbuf, 0, 0)
			Catch ex As SocketException
				obj = New String() {ex.Message}
				Me.listBox.Invoke(dlgDisplay, obj)
			End Try
		End Sub

		Public Sub Close()
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				Me.LocalsocketClientIsShutingDown = True
				Me.SocketClient.Shutdown(SocketShutdown.Both)
				Me.SocketClient.Close
				Dim obj As String() = New String() {"Connexion ferme"}
				Me.listBox.Invoke(dlgDisplay, obj)
			End If
		End Sub

		Private Sub DisplayMessage(ByVal message As String)
			Me.listBox.Items.Add(message)
			Me.listBox.SelectedIndex = Me.listBox.Items.Count - 1
		End Sub
	End Class 
End Namespace
