Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Windows.Forms
Namespace Server

	Public Class ServerClass
		Private SocketServer As Socket
		Private SocketClient As Socket
		Private LocalsocketClientIsShutingDown As Boolean = False
		Private readbuf As Byte()
		Private sendbuf As Byte()
		Private listBox As ListBox

		private Delegate Sub DelegateDisplay(ByVal message As String)
		private dlgDisplay as DelegateDisplay = new DelegateDisplay(addressof DisplayMessage)
		

		Public Sub New(ByVal list As ListBox)
			Me.listBox = list
			Me.readbuf = New Byte(100) {}
		End Sub

		Public Sub RunServer()
			Me.SocketServer = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
			Dim ipadress As IPAddress()
			Dim he As IPHostEntry = Dns.GetHostByName(Dns.GetHostName)
			ipadress = he.AddressList
			Me.SocketServer.Bind(New IPEndPoint(ipadress(0), 15))
			Me.SocketServer.Listen(1)
			Me.SocketServer.BeginAccept(AddressOf ConnectionAcceptCallback, Me.SocketServer)
			DisplayMessage("Serveur lanc")
		End Sub

		Private Sub ConnectionAcceptCallback(ByVal asyncResult As IAsyncResult)
			Dim obj As String()
			Try
				Dim socket As Socket = CType(asyncResult.AsyncState, Socket)
				If Not (socket.Handle.ToInt32 = -1) Then
					Me.SocketClient = socket.EndAccept(asyncResult)
					Me.LocalsocketClientIsShutingDown = False
					obj = New String() {"Un client s'est connect"}
					Me.listBox.Invoke(dlgDisplay, obj)
					Me.SocketClient.BeginReceive(Me.readbuf, 0, Me.readbuf.Length, SocketFlags.None, AddressOf ReceiveMessageCallback, Me.SocketClient)
				End If
			Catch ex As SocketException
				obj = New String() {ex.Message}
				Me.listBox.Invoke(dlgDisplay, obj)
			End Try
		End Sub

		Public Sub ReceiveMessage()
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				Me.SocketClient.BeginReceive(Me.readbuf, 0, Me.readbuf.Length, SocketFlags.None, AddressOf ReceiveMessageCallback, Me.SocketClient)
			Else
				DisplayMessage("Client non connect")
			End If
		End Sub

		Private Sub ReceiveMessageCallback(ByVal asyncResult As IAsyncResult)
			Dim displaydata As String()
			Try
				Dim socket As Socket = CType(asyncResult.AsyncState, Socket)
				Dim read As Integer = socket.EndReceive(asyncResult)
				If read > 0 Then
					displaydata = New String() {"Client dit : " + Encoding.ASCII.GetString(Me.readbuf)}
					Me.listBox.Invoke(dlgDisplay, displaydata)
					Buffer.SetByte(Me.readbuf, 0, 0)
					Me.SocketClient.BeginReceive(Me.readbuf, 0, Me.readbuf.Length, SocketFlags.None, AddressOf ReceiveMessageCallback, Me.SocketClient)
				End If
				If read = 0 AndAlso Not Me.LocalsocketClientIsShutingDown Then
					socket.Close
					displaydata = New String() {"Socket distante ferme."}
					Me.listBox.Invoke(dlgDisplay, displaydata)
					Me.SocketServer.BeginAccept(AddressOf ConnectionAcceptCallback, Me.SocketServer)
				End If
			Catch ex As SocketException
				displaydata = New String() {ex.Message}
				Me.listBox.Invoke(dlgDisplay, displaydata)
			End Try
		End Sub

		Public Sub Send(ByVal message As String)
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				Me.sendbuf = Encoding.ASCII.GetBytes(message)
				Me.SocketClient.BeginSend(Me.sendbuf, 0, Me.sendbuf.Length, SocketFlags.None, AddressOf SendCallback, Me.SocketClient)
			Else
				DisplayMessage("Client non connect")
			End If
		End Sub

		Private Sub SendCallback(ByVal asyncResult As IAsyncResult)
			Dim listdata As String()
			Try
				Dim socket As Socket = CType(asyncResult.AsyncState, Socket)
				Dim send As Integer = socket.EndSend(asyncResult)
				listdata = New String() {"Message envoy (" + send.ToString() + " octets)"}
				Me.listBox.Invoke(dlgDisplay, listdata)
			Catch ex As SocketException
				listdata = New String() {ex.Message}
				Me.listBox.Invoke(dlgDisplay, listdata)
			End Try
		End Sub

		Public Sub CloseClient()
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				Me.LocalsocketClientIsShutingDown = True
				Me.SocketClient.Shutdown(SocketShutdown.Both)
				Me.SocketClient.Close
				Me.SocketServer.BeginAccept(AddressOf ConnectionAcceptCallback, Me.SocketServer)
			End If
			DisplayMessage("Client arrt")
		End Sub

		Public Sub CloseServer()
			If Not (Me.SocketClient Is Nothing) AndAlso Me.SocketClient.Connected Then
				CloseClient
			End If
			If Not (Me.SocketServer Is Nothing) AndAlso Not (Me.SocketServer.Handle.ToInt32 = -1) Then
				Me.SocketServer.Close
			End If
			DisplayMessage("Serveur arrt")
		End Sub

		Private Sub DisplayMessage(ByVal message As String)
			Me.listBox.Items.Add(message)
			Me.listBox.SelectedIndex = Me.listBox.Items.Count - 1
		End Sub
	End Class 
End Namespace
